<?php

use Contao\Backend;
use Contao\BackendUser;
use Contao\DC_Table;

use Contao\DataContainer;

/**
 * Table tl_popup 
 */
$GLOBALS['TL_DCA']['tl_popup'] = array
    (
    // Config
    'config' => array
        (
        'dataContainer' => DC_Table::class,
        'ptable' => 'tl_popup_set',
        'ctable' => array('tl_content'),
        'switchToEdit' => true,
        'enableVersioning' => true,
        'sql' => array
            (
            'keys' => array
                (
                'id' => 'primary',
                'pid,sorting,published' => 'index'
            )
        )
    ),
    // List
    'list' => array
        (
        'sorting' => array
            (
            'mode' => 4,
            'fields' => array('sorting'),            
            'headerFields' => array('title', 'tstamp', 'protected'),
            'panelLayout' => 'search,limit',
            'child_record_callback' => array('tl_popup', 'showPreview'),
            'child_record_class' => 'no_padding'
        ),
        'global_operations' => array
            (
            'all' => array
                (
                'label' => &$GLOBALS['TL_LANG']['MSC']['all'],
                'href' => 'act=select',
                'class' => 'header_edit_all',
                'attributes' => 'onclick="Backend.getScrollOffset()" accesskey="e"'
            )
        ),
		'operations' => array
		(
			'edit' => array
			(
				'href'                => 'act=edit',
				'icon'                => 'edit.svg'
			),
			'children' => array
			(
				'href'                => 'table=tl_content',
				'icon'                => 'children.svg'
			),
			'copy' => array
			(
				'href'                => 'act=paste&amp;mode=copy',
				'icon'                => 'copy.svg'
			),
			'cut' => array
			(
				'href'                => 'act=paste&amp;mode=cut',
				'icon'                => 'cut.svg'
			),
			'delete' => array
			(
				'href'                => 'act=delete',
				'icon'                => 'delete.svg',
				'attributes'          => 'onclick="if(!confirm(\'' . ($GLOBALS['TL_LANG']['MSC']['deleteConfirm'] ?? null) . '\'))return false;Backend.getScrollOffset()"'
			),
			'toggle' => array
			(
				'href'                => 'act=toggle&amp;field=published',
				'icon'                => 'visible.svg',
				'showInHeader'        => true
			),
			//'feature' => array
			//(
			//	'href'                => 'act=toggle&amp;field=featured',
			//	'icon'                => 'featured.svg',
			//),
			'show' => array
			(
				'href'                => 'act=show',
				'icon'                => 'show.svg'
			)
		)
    ),
    // Palettes
    'palettes' => array
        (
        'default' => '{title_legend},title,customId,pages;{position_legend},position;{appearance_legend},appearance,delay,scrollOffset,cookieExpire;{expert_legend:hide},cssClass,template;{publish_legend},published,start,stop'
    ),
    // Fields
    'fields' => array
        (
        'id' => array
            (
            'sql' => "int(10) unsigned NOT NULL auto_increment"
        ),
        'pid' => array
            (
            'foreignKey' => 'tl_popup_set.title',
            'sql' => "int(10) unsigned NOT NULL default '0'",
            'relation' => array('type' => 'belongsTo', 'load' => 'eager')
        ),
        'tstamp' => array
            (
            'sql' => "int(10) unsigned NOT NULL default '0'"
        ),
        'sorting' => array
            (
            'sql' => "int(10) unsigned NOT NULL default '0'"
        ),
        'title' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['title'],
            'exclude' => true,
            'search' => true,
            'sorting' => false,
            'flag' => 1,
            'inputType' => 'text',
            'eval' => array('mandatory' => true, 'maxlength' => 255, 'tl_class' => 'w50'),
            'sql' => "varchar(255) NOT NULL default ''"
        ),
        'customId' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['customId'],
            'inputType' => 'text',
            'eval' => array('maxlength' => 255, 'tl_class' => 'w50'),
            'save_callback' => array
            (
                array('tl_popup', 'generateCustomId')
            ),
            'sql' => "varchar(255) NOT NULL default ''"
        ),
        'pages' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['pages'],
            'exclude'                 => true,
            'inputType'               => 'pageTree',
            'eval'                    => array('multiple'=>true, 'fieldType'=>'checkbox', 'mandatory' => false, 'tl_class' => 'clr'),
            'sql'                     => "blob NULL",
            //'save_callback' => array
            //    (
            //    array('tl_popup', 'saveSliderPages'),
            //)
        ),
        'position' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['position'],
            'default'               => 'center',
            'exclude'               => true,
            'inputType'             => 'radioTable',
            'options'               => array(
                'center',
                'top-left',
                'top-right',
                'bottom-left',
                'bottom-right'
            ),
            'eval'                  => array('mandatory' => true, 'cols'=>5),
            //'reference'             => &$GLOBALS['TL_LANG']['tl_popup'],
            'sql'                   => "varchar(32) NOT NULL default ''"
        ),
        'appearance' => array 
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['appearance'],
            'default'               => 'onPageLoad',
            'exclude'               => true,
            'inputType'             => 'radio',
            'options'               => array(
                'onPageLoad'    => &$GLOBALS['TL_LANG']['tl_popup']['appearance']['onPageLoad'], 
                'onScroll'      => &$GLOBALS['TL_LANG']['tl_popup']['appearance']['onScroll']
            ),
            'eval'                  => array('mandatory' => true, 'tl_class'=>'clr'),
            'sql'                   => "char(200) NOT NULL default ''"
        ),
        'delay' => array 
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['delay'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('tl_class'=>'w50 validateNumbers delay', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '1000'"
        ),
        'scrollOffset' => array 
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['scrollOffset'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('tl_class'=>'w50 validateNumbers scrollOffset', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '300'"
        ),
        'cookieExpire' => array 
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['cookieExpire'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('mandatory' => true, 'tl_class'=>'w50 validateNumbers', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '7'"
        ),
        'cssClass' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['cssClass'],
            'exclude' => true,
            'inputType' => 'text',
            'eval' => array('tl_class'=>'clr w50'),
            'sql' => "varchar(255) NOT NULL default ''"
        ),
        'template' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['template'],
            'exclude' => true,
            'inputType' => 'select',
            'options_callback' => array('tl_popup', 'getPopupTemplates'),
            'eval' => array('tl_class'=>'w50'),
            'sql' => "varchar(64) NOT NULL default 'popup_default'"
        ),
        'published' => array
            (
            'toggle'                  => true,
            'filter'                  => true,
            'flag'                    => DataContainer::SORT_INITIAL_LETTER_ASC,
            'inputType'               => 'checkbox',
            'eval'                    => array('doNotCopy'=>true),
            'sql'                     => array('type' => 'boolean', 'default' => false)
        ),
        'start' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['start'],
            'exclude' => true,
            'inputType' => 'text',
            'eval' => array('rgxp' => 'datim', 'datepicker' => true, 'tl_class' => 'w50 wizard'),
            'sql' => "varchar(10) NOT NULL default ''"
        ),
        'stop' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['stop'],
            'exclude' => true,
            'inputType' => 'text',
            'eval' => array('rgxp' => 'datim', 'datepicker' => true, 'tl_class' => 'w50 wizard'),
            'sql' => "varchar(10) NOT NULL default ''"
        )
    )
);

/**
 * Class tl_popup
 */
class tl_popup extends Backend {

	/**
	 * Import the back end user object
	 */
	public function __construct()
	{
		parent::__construct();
		$this->import(BackendUser::class, 'User');
	}

    /**
     * Check permissions to edit table tl_popup
     */
    public function checkPermission() {
        
        if ($this->User->isAdmin) {
            return;
        }

        // Set the root IDs
        if (!is_array($this->User->menus) || empty($this->User->menus)) {
            $root = array(0);
        } else {
            $root = $this->User->menus;
        }

        $id = strlen(Input::get('id')) ? Input::get('id') : CURRENT_ID;

        // Check current action
        switch (Input::get('act')) {
            case 'paste':
                // Allow
                break;

            case 'create':
                if (!strlen(Input::get('pid')) || !in_array(Input::get('pid'), $root)) {
                    $this->log('Not enough permissions to create menu items in popup ID "' . Input::get('pid') . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
                break;

            case 'cut':
            case 'copy':
                if (!in_array(Input::get('pid'), $root)) {
                    $this->log('Not enough permissions to ' . Input::get('act') . ' menu item ID "' . $id . '" to popup ID "' . Input::get('pid') . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
            // NO BREAK STATEMENT HERE

            case 'edit':
            case 'show':
            case 'delete':            
            case 'feature':
                $objArchive = $this->Database->prepare("SELECT pid FROM tl_popup WHERE id=?")
                        ->limit(1)
                        ->execute($id);

                if ($objArchive->numRows < 1) {
                    $this->log('Invalid menu item ID "' . $id . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }

                if (!in_array($objArchive->pid, $root)) {
                    $this->log('Not enough permissions to ' . Input::get('act') . ' menu item ID "' . $id . '" of popup ID "' . $objArchive->pid . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
                break;

            case 'toggle':
                // did not work as part of the group above
                if (!in_array('tl_popup::published', $this->User->alexf)) {
                    $this->log('Not enough permissions to ' . Input::get('act') . ' menu item ID "' . $id . '" of popup ID "' . $objArchive->pid . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
                break;     
                
            case 'select':
            case 'editAll':
            case 'deleteAll':
            case 'overrideAll':
            case 'cutAll':
            case 'copyAll':
                if (!in_array($id, $root)) {
                    $this->log('Not enough permissions to access popup ID "' . $id . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }

                $objArchive = $this->Database->prepare("SELECT id FROM tl_popup WHERE pid=?")
                        ->execute($id);

                if ($objArchive->numRows < 1) {
                    $this->log('Invalid popup ID "' . $id . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }

                $session = $this->Session->getData();
                $session['CURRENT']['IDS'] = array_intersect($session['CURRENT']['IDS'], $objArchive->fetchEach('id'));
                $this->Session->setData($session);
                break;

            default:
                if (strlen(Input::get('act'))) {
                    $this->log('Invalid command "' . Input::get('act') . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                } elseif (!in_array($id, $root)) {
                    $this->log('Not enough permissions to access popup ID ' . $id, 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
                break;
        }
    }
    
    /**
     * Add the type of input field
     * @param array
     * @return string
     */
    public function showPreview($arrRow) {

        $period = "";
        if ($arrRow['start']) {
            $period .= '<span class="start">Start: ' . date("d-m-Y H:i",$arrRow['start']) . '</span>';
        } else {
            $period .= '<span class="start">Start: -undefiniert-</span>';
        }
        if ($arrRow['stop']) {
            $period .= '<br><span class="stop">Stop: ' . date("d-m-Y H:i",$arrRow['stop']) . '</span>';
        } else {
            $period .= '<br><span class="stop">Stop: -undefiniert-</span>';    
        }

        return '<div class="tl_content_left tl_popup"><strong>' . $arrRow['title'] . '</strong><br><span class="period" style="opacity: 0.8; font-size: 0.9em;">'.$period.'</span></div>';
    }

    /**
     * Auto-generate the popup custom id if it has not been set yet
     *
     * @param mixed                $varValue
     * @param Contao\DataContainer $dc
     *
     * @return string
     *
     * @throws Exception
     */
    public function generateCustomId($varValue, Contao\DataContainer $dc)
    {
        $aliasExists = function (string $alias) use ($dc): bool
        {
            return $this->Database->prepare("SELECT id FROM tl_popup WHERE customId=? AND id!=?")->execute($alias, $dc->id)->numRows > 0;
        };

        // Generate alias if there is none
        if ($varValue == '')
        {
            $varValue = substr(md5(uniqid(rand(), true)), 0, 8); // returns random 8 character long string
        }
        elseif ($aliasExists($varValue))
        {
            throw new Exception(sprintf($GLOBALS['TL_LANG']['ERR']['aliasExists'], $varValue));
        }

        return $varValue;
    }

    /**
     * Return all popup templates as array
     *
     * @return array
     */
    public function getPopupTemplates()
    {
        return $this->getTemplateGroup('popup_');
    }


}